import 'package:flutter/material.dart';
import 'packages/action_widget/lib/ui/components/event_widget_anim.dart';
import 'packages/action_widget/lib/ui/components/listener_widget.dart';

void main() => runApp(MyApp());

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

// ignore: must_be_immutable
class MyHomePage extends StatefulWidget{

  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;
  MyHomePageState myHomePageState;

  @override
  State<StatefulWidget> createState() {
    myHomePageState = MyHomePageState();
    return myHomePageState;
  }

}

//implementation interface action
class MyHomePageState extends State<MyHomePage> with ActionListenerWidget {

  MyHomePageState();

  Container container;

  @override
  void initState() {
    super.initState();
    container = _container();
  }

  @override
  Widget build(BuildContext context) {

    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Center(
        //animation listener widget
        child: EventWidgetAnim(child: container,
          actionListener: this,),
      ),
    );
  }


  Container _container(){

    return Container(
      key: Key("id_container"),
      color: Colors.grey,
      height: 50,
      width: 200,
    );
  }


  @override
  void manageTapClick(String value) {
    // TODO: implement manageTapClick
    switch(value){

      case "id_container":
        print(value);
        break;

    }
  }

}
