import 'package:flutter/material.dart';
import 'listener_widget.dart';


// ignore: must_be_immutable
class EventWidgetAnim extends StatefulWidget {

  Widget child;
  ActionListenerWidget actionListener;

  EventWidgetAnim({@required this.child, @required this.actionListener});

  @override
  _EventWidgetAnimState createState() => _EventWidgetAnimState(this.child, this.actionListener);
}

class _EventWidgetAnimState extends State<EventWidgetAnim>
    with SingleTickerProviderStateMixin {

  double _scale;
  AnimationController _controller;
  Widget uiWidget;
  ActionListenerWidget actionListener;

  _EventWidgetAnimState(this.uiWidget, this.actionListener);

  @override
  void initState() {

    super.initState();

    _controller = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 200),
      lowerBound: 0.0,
      upperBound: 0.1,
    )..addListener(() {
      setState(() {});
    });
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  void _onTapDown(TapDownDetails details) {
    _controller.forward();
  }

  void _onTapUp(TapUpDetails details) {
    _controller.reverse();
  }

  @override
  Widget build(BuildContext context) {

    _scale = 1 - _controller.value;

    return GestureDetector(
      onTapDown: _onTapDown,
      onTapUp: _onTapUp,
      onTap: (){_processFinish();},
      child: Transform.scale(
        scale: _scale,
        child: this.uiWidget,
      ),
    );
  }

  _processFinish() {

    String value = actionListener.fomartKeyValue(this.uiWidget);
    this.actionListener.manageTapClick(value);
  }

}